
CON
 '' wifi tester by Jim Meek

 '' This program interacts with Propeller keyboard/VGA and Propeller Terminal at the same time.
 '' Local/Terminal commands are: ?=Redisplay Help Screen / !=Test/Display Bluetooth Firmware

  _xinfreq      = 5_000_000      
  _clkmode      = xtal1 + pll16x   

  W_TX_PIN     = 2          '' Change I/O for connection to W TX Pin.
  W_RX_PIN     = 3          '' Change I/O for connection to W RX Pin.
  W_BAUD       = 57600      '' 
  VG_PIN        = 16
  KB_PIN        = 26
'  TERM_BAUD     = 115200
  Pin           =20
  Pin2          =21
  LED_Pin       =24
  _clockDataPin = 1
  _clockClockPin =0
  _clock_int_Pin =7
  ALTITUDE      =1817
  out           =1
  in            =0
  on            =1
  off           =0
  CR            =$0D
  LF            =$0A
  Null          = $00
  Qmark         = $3F
  FSlash         = $2F       '' /
  BSlash        = $5C        ''\
  US_001 = 80_000_000 / 1_000_000                            ' 5us
  WebPort       = 01
  Debug         = 0
  NOMODE                        = %000000
  INVERTRX                      = %000001
  INVERTTX                      = %000010
  OCTX                          = %000100
  NOECHO                        = %001000
  INVERTCTS                     = %010000
  INVERTRTS                     = %100000

  PINNOTUSED                    = -1                    'tx/tx/cts/rts pin is not used
  DEFAULTTHRESHOLD              = 0                     ' zero defaults to 3/4 of buffer length

  BAUD1200                      = 1200
  BAUD2400                      = 2400
  BAUD4800                      = 4800
  BAUD9600                      = 9600
  BAUD19200                     = 19200
  BAUD38400                     = 38400
  BAUD57600                     = 57600
  BAUD115200                    = 115200
  DEBUG_BAUD                    = BAUD115200
{
  ' The following constants declare the sizes of the rx and tx buffers.  The values show are the same
  ' as the original by default, but please feel free to change these sizes when needed.
  TX_SIZE0                      = 32  ' enter in the needed size in bytes for each rx and tx buffer
  TX_SIZE1                      = 2048  ' these values can be any size within available memory.
  TX_SIZE2                      = 32  ' They do not have to be a power of two.
  TX_SIZE3                      = 32   '

  RX_SIZE0                      = 64
  RX_SIZE1                      = 2048
  RX_SIZE2                      = 64
  RX_SIZE3                      = 64
  RXTX_BUFSIZE                  = (TX_SIZE0 + TX_SIZE1 + TX_SIZE2 + TX_SIZE3 + RX_SIZE0 + RX_SIZE1 + RX_SIZE2 + RX_SIZE3)
                                 ' total buffer footprint in bytes
                                 ' 77 longs, 308 bytes are available for buffers within the hub footprint of the object
                                 ' the final instruction in this program allocates additional buffer space beyond that if necessary
                                 ' to accomodate all of the buffers.
                                 ' if the sum totals to 308, then the buffers exactly fit within the object footprint.
                       ' 
 }
OBJ
  fds        :"FullDuplexSerial4port"
  dio        :"DataIO4port"
  text        : "VGA_HiRes_Text_Terminal"  
'  kbd         : "comboKeyboard"
 ' web         : "FullDuplexSerial_2k_051414"
  str         : "ASCII0_STREngine"
  bar         : "29124_altimeter"
  rtc         : "DS3231_RTCEngine_61614"
VAR

  long stringPointer
  long foxCog, stack[40]                                  ' for the new cog started to transmit data
  long loopCount                                          ' to keep track of how many times the uarts have been restarted                         '
  long fdsDatPtr                                          ' a pointer to the data structure within fullDuplexSerial4port, for the buffer sizes
  long webstack[64]
  byte stringBuffer[64]
  byte stringBuffer2[64]
  byte temp_str[20]
  
 
PUB main | rxb, rxc, key,index ,s,t,x,y,sp,p,cm,deg,character
  text.start(VG_PIN) 
'  kbd.start(KB_PIN)
  Pause(100)
  Start_Uarts
  rtc.rtcEngineStart(_clockDataPin, _clockClockPin, -1)
  fds.rxflush(webport)
  fds.txflush(webport)
  bar.start(bar#MOBO_B, bar#BACKGROUND)
  dira[_clock_int_pin]~
  dira[LED_Pin]~~
      
  cognew (webthread,@webstack)
  repeat {
    programDate
    waitcnt(US_001*1000000+cnt)
          }
PUB start_uarts
'' port 0-3 port index of which serial port
'' rx/tx/cts/rtspin pin number                          #PINNOTUSED = -1  if not used
'' prop debug port rx on p31, tx on p30
'' cts is prop input associated with tx output flow control
'' rts is prop output associated with rx input flow control
'' rtsthreshold - buffer threshold before rts is used   #DEFAULTTHRSHOLD = 0 means use default=buffer 3/4 full
''                                                      note rtsthreshold has no effect unless RTS pin is enabled
'' mode bit 0 = invert rx                               #INVERTRX  bit mask
'' mode bit 1 = invert tx                               #INVERTTX  bit mask
'' mode bit 2 = open-drain/source tx                    #OCTX   bit mask
'' mode bit 3 = ignore tx echo on rx                    #NOECHO   bit mask
'' mode bit 4 = invert cts                              #INVERTCTS   bit mask
'' mode bit 5 = invert rts                              #INVERTRTS   bit mask
'' baudrate                                             desired baud rate, e.g. 9600

  if foxCog                                             ' stopping transmission from the ansynchronous foxCpg
    cogstop(foxCog-1)
  pause(100)

  fdsDatPtr := fds.init                                 ' clears the buffers and pointers, returns a pointer to the internal fds data structure

  fds.AddPort(webport,W_RX_PIN,W_TX_PIN,-1,-1,0,%000000,w_baud)

  fds.AddPort(DEBUG,31,30,-1,-1,0,%000000,DEBUG_BAUD)   ' debug to the terminal screen

' port 1 is not used.   The order that you define ports does not matter.  You don't have to do anything to set up unused ports

  fds.Start                                             ' now actually start the ports
  pause(100)                                            '

    
PUB programDate |a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,time_pointer,year


    M:=cnt
    ifnot(rtc.readTime)
      abort text.str(string("Operation Failed", LF))
{    N:=cnt
    N-=m
    N/=US_001
    text.str(string(" n-m in microseconds "))
    text.dec(n)
    dio.dec(debug,n)
    fds.str(debug,string(" n-m in microseconds "))}   
    year:=str.integerToDecimal(rtc.clockyear,4)    
      
    result:=str.stringcopy(@Time_info,lookup(rtc.clockDay: string("Sunday"), {
                                          } string("Monday"), {
                                          } string("Tuesday"),  {
                                          } string("Wednesday"), {
                                          } string("Thursday"), {
                                          } string("Friday"), {
                                          } string("Saturday")))
    a:=strsize(result)
    result:=str.stringcopy(@time_info+a,string(", "))
    result:=str.stringcopy(@time_info+a+2,lookup(rtc.clockMonth: string("January"), {
                                            } string("Feburary"), {
                                            } string("March"), {
                                            } string("April"), {
                                            } string("May"), {
                                            } string("June"), {
                                            } string("July"),  {
                                            } string("August"), {
                                            } string("September"), {
                                            } string("October"), {
                                            } string("November"), {
                                            } string("December")))
    b:=strsize(result)                                       
    time_pointer:=a+b+2
    
    result:=str.stringcopy(@time_info+time_pointer,string(" "))
    time_Pointer++
    c:=@time_info + time_Pointer
    d:=upper_nibble(rtc.clockDate)
    bytefill(c,d,1)
    c++
    e:=lower_nibble(rtc.clockDate)
    bytefill(c,e,1)
    c ++
    
    result:=str.stringcopy(c,string(", "))
    c+=2
    f:=c
    year++
    bytemove (f,year,4)
    c+=4
    text.str(string("  "))
    c ++
    result:=str.stringcopy(c,string("  "))
    c+=2
    d:=upper_nibble(rtc.clockMeridiemHour)
    e:=lower_nibble(rtc.clockMeridiemHour)
    bytefill(c,d,1)
    c++
    bytefill(c,e,1)
    c ++
    result:=str.stringcopy(c,string(":"))
    c++
    d:=upper_nibble(rtc.clockMinute)
    e:=lower_nibble(rtc.clockMinute)
       
    bytefill(c,d,1)
    c++
    bytefill(c,e,1)
    c ++
    result:=str.stringcopy(c,string(":"))
    c++
    d:=upper_nibble(rtc.clockSecond)
 '   repeat while e<$30 or E>$39  
    e:=lower_nibble(rtc.clockSecond)
       
    bytefill(c,d,1)
    c++
    bytefill(c,e,1)
    c ++
    result:=str.stringcopy(c,string("  "))
    c+=2


    if(rtc.clockMeridiemTime)
      result:=str.stringcopy(c,string("PM", cr,lf))
    else
    
      result:=str.stringcopy(c,(string("AM",cr,lf)))
    text.str(@time_info)
    
      

Pri upper_nibble(PARM)|temp    
    temp:=Parm>>4 &$0F
    temp+= $30
    return temp

Pri Lower_nibble(Parm)|temp
    temp:=Parm &$0F + $30
    return temp

PRI pause(ms)
  waitcnt(clkfreq/1000*ms + cnt)
    
PUB webthread
   dira [Pin] ~~
   dira [Pin2]~~

   Repeat
      web_check      
      String_parse
      fds.rxflush(webport)
      text.str(string("contents of stringbuffer2 "))
      text.str(string(cr,lf))
      text.str(@Stringbuffer2)

 
      fds.str(webport,string("1"))              '(cr,lf))

      ifnot str.stringCompareCI(@StringBuffer2,@ControlString0)
         command0
      ifnot str.stringCompareCI(@StringBuffer2,@ControlString1)
         command1
      ifnot str.stringCompareCI(@StringBuffer2,@controlString2 )
         command2
      ifnot str.stringCompareCI(@StringBuffer2,@controlString3)
         command3
      ifnot str.stringCompareCI(@StringBuffer2, @controlString4)
         command4  
'      else
       
'         fds.str(string("<html><body> IF YOU HAVE REACHED THIS PAGE YOU DON'T BELONG, GET OUT!!!"))
      pause (500)
      fds.rxflush (webport)

PRI web_check   |rxb
      repeat
        rxb := fds.rxcheck(webport)

          if rxb <> -1                
                text.out(rxb)
         
                str.buildString(rxb)
           
      while((rxb <> CR) and (rxb <> LF) and (rxb <> NULL))
'      fds.rxflush(webport)

Pri String_Parse |String_Start,String_end,String_len,x
      StringPointer :=str.trimString( str.builtString(true))
      String_start:= STR.FindCharacter(StringPointer,FSlash)
      String_start++ 
      str.stringCopy(@StringBuffer,String_start)
      String_end:= STR.FindCharacter(@Stringbuffer,FSlash)
      string_len:=String_end - @stringBuffer 
      bytefill(@StringBuffer2,Null,String_len)
      bytemove(@StringBuffer2,@Stringbuffer,String_len-5)
      Return @StringBuffer2


PRI Command0   | x,y       'power=0
    
      outa[pin]:=off
      fds.str(webport,@Page_header)
      x:=ina[pin]
      if x==on
         fds.str(webport,@Power_on1)
      else
        fds.str(webport,@Power_off1)
      
      Y:=ina[pin2]
      if Y==on
        fds.str (webport,@Power_on2)
      else
        fds.str (webport,@Power_off2)

      fds.str(webport,@Page_body)
      weatherCommand
      return
PRI Command1 |x,y      'power=1
      outa[pin]:=on 'Turn On power on Pin
      fds.str(webport,@Page_header)
      x:=ina[pin]
      if x==on
         fds.str(webport,@Power_on1)
      else
        fds.str(webport,@Power_off1)
      
      Y:=ina[pin2]
      if Y==on
        fds.str (webport,@Power_on2)
      else
        fds.str (webport,@Power_off2)
      fds.str(webport,@Page_body)
      weatherCommand
      return

PRI Command2  |x,y   'power=2


      outa[pin2]:=off 'Turn off power on Pin 2
      fds.str(webport,@Page_header) 
       x:=ina[pin]
      if x==on
         fds.str(webport,@Power_on1)
      else
        fds.str(webport,@Power_off1)
      
      Y:=ina[pin2]
      if Y==on
        fds.str (webport,@Power_on2)
      else
        fds.str (webport,@Power_off2)
     fds.str(webport,@Page_body) 
      weatherCommand
      Return

PRI Command3 |x,y    'Power = 3
  
      outa[pin2]:=on 
      fds.str(webport,@Page_header)
      x:=ina[pin]
      if x==on
         fds.str(webport,@Power_on1)
      else
        fds.str(webport,@Power_off1)
      
      Y:=ina[pin2]
      if Y==on
        fds.str (webport,@Power_on2)
      else
        fds.str (webport,@Power_off2)

      fds.str(webport,@Page_body)

      weatherCommand
      Return

PRI Command4  |s,t

      fds.str(webport,@Page_header) 
 
      s:=ina[pin]
      if s==on
        fds.str(webport,@Power_on1)
      else
        fds.str(webport,@Power_off1)
      t:=ina[pin2]
        if t==on
          fds.str(webport,@Power_on2)
        else
          fds.str(webport,@Power_off2)
      fds.str(webport,@Page_body)
      weatherCommand
      return
      
PRI weatherCommand | sp,deg,p,cm,String_start
      cm := bar.m_from_ft(ALTITUDE * 100)                       ' Convert altitude in feet to cm.
      bar.pause
      p := bar.average_press                                  ' Get the average pressure.
      sp := bar.sealevel_press(p, cm)                         ' Convert to equivalent sea-level pressure, given altitude.
      deg :=bar.current_temp
      bar.resume
      str.stringcopy (@temp_str,(bar.formatn(sp,bar#TO_INCHES,8)))
      fds.str(webport,@pressure)
      fds.str(webport,@temp_str)
      fds.str(webport,@Line_break)
      str.stringcopy (@temp_str,(bar.formatn(deg,bar#TO_DEGF,8)))      
      fds.str(webport,@temperature)
      fds.str(webport,@Temp_str)
      fds.str(webport,@Line_break)
      fds.str(webport,@Line_break)
      fds.str(webport,@time_info)
      fds.str(webport,@Line_break)

      return

DAT
                 byte 0 
 ControlString0  byte "control.htm?Power=0"
                 byte 0 
 ControlString1  byte "control.htm?Power=1"
                 byte 0 
 ControlString2  byte  "control.htm?Power=2"
                 byte 0 
 ControlString3  byte  "control.htm?Power=3"
                 byte 0 
 ControlString4  byte "control.htm?"
                 byte 0 
  
 Page_header  byte "<html> <head > <meta content=",34,"text/html; charset=ISO-8859-1",34
              byte"http-equiv=",34,"Content-Type",34,"><title>Jim's server</title></head>"
              byte" <body bgcolor=",34,"Green",34, ">" 
              byte" <h1 align=",34,"center",34,">Jim's Home Control and weather System</h1><br><br>"
              byte 0
  Power_on1    byte " <div align=" ,34,"center",34,"> <pre> <font size=",34,"+2",34,">   Printer Power is On  "
              byte 0     
 Power_off1   byte " <div align=",34,"center",34,"> <pre> <font size=",34,"+2",34,">   Printer Power is Off "
              byte 0     
 Power_on2    byte "  Main Power is On <BR><BR></pre></font></div>"
              byte 0     
 Power_off2   byte "  Main Power is Off <BR><BR></pre></font></div>"
              byte 0     

 Page_body    byte "<div align=",34,"center",34,"> <pre> <font size=",34,"+2",34,"> Press Buttons to toggle power<br><form>"
              byte "<pre> <font size=",34,"+2",34,"><pre>"
              byte"<input type=  radio name=Power value=1 />  Printer Power On "     ' <br /
              byte"<input type=  radio name=Power value=0 />  Printer Power Off <br /></pre><font>  "
              byte "<input type=  radio name=Power value=3 /> Main Power On "    '<br />
              byte"<input type=  radio name=Power value=2 />  Main Power Off  "
              byte"<form><BR>" 
              byte"<form><BR>" 
              byte"<input type=submit />"   
              byte 0
 Pressure     Byte  "<div align=",34,"center",34,"> <pre> <font size=",34,"+2",34,">Sea Leval Pressure ="
              Byte 0
 Temperature  Byte  "<div align=",34,"center",34,"> <pre> <font size=",34,"+2",34,">Indoor Temperature ="
              Byte 0
 Line_break   Byte "<form><BR>"           
              byte 0
 Time_info    Byte "                                                                                      "
              Byte 0 

DAT                                    'names of the days and months

Day0    BYTE  "  NoDay   ", 0
Day1    BYTE  "  Sunday  ", 0
Day2    BYTE  "  Monday  ", 0
Day3    BYTE  " Tuesday  ", 0
Day4    BYTE  " Wednesday", 0
Day5    BYTE  " Thursday ", 0
Day6    BYTE  "  Friday  ", 0
Day7    BYTE  " Saturday ", 0


SMon0   BYTE  "Nul", 0
SMon1   BYTE  "Jan", 0
SMon2   BYTE  "Feb", 0
SMon3   BYTE  "Mar", 0
SMon4   BYTE  "Apr", 0
SMon5   BYTE  "May", 0
SMon6   BYTE  "Jun", 0
SMon7   BYTE  "Jul", 0
SMon8   BYTE  "Aug", 0
SMon9   BYTE  "Sep", 0
SMon10  BYTE  "Oct", 0
SMon11  BYTE  "Nov", 0
SMon12  BYTE  "Dec", 0
        
           